//
// Created by yahboom on 2021/4/29.
//

#include "ros/ros.h"
#include <sensor_msgs/Image.h>
#include <cv_bridge/cv_bridge.h>
#include <sensor_msgs/image_encodings.h>
#include <opencv2/highgui/highgui.hpp>

using namespace std;
using namespace cv;

void depth_Callback(const sensor_msgs::ImageConstPtr &msg) {
    cv_bridge::CvImagePtr cv_ptr;
    try {
        cv_ptr = cv_bridge::toCvCopy(msg, sensor_msgs::image_encodings::TYPE_16UC1);
        imshow("depth_image", cv_ptr->image);
        waitKey(1);
    } catch (cv_bridge::Exception &e) {
        ROS_ERROR("cv_bridge exception: %s", e.what());
        return;
    }
}

int main(int argc, char **argv) {
    //ROS节点初始化
    ros::init(argc, argv, "astra_depth_image_cpp");
    //创建节点句柄
    ros::NodeHandle n;
    //创建一个接收者.
    ros::Subscriber subscriber = n.subscribe<sensor_msgs::Image>("/camera/depth/image_raw", 10, depth_Callback);
    //按照循环频率延时
    ros::spin();
    return 0;
}
