//
// Created by yahboom on 2021/4/29.
//

#include <iostream>
#include <ros/ros.h>
#include <pcl/point_types.h>
#include <pcl_conversions/pcl_conversions.h>
#include <sensor_msgs/PointCloud2.h>

int main(int argc, char **argv) {
    //初始化了一个节点
    ros::init(argc, argv, "pub_pcl");
    ros::NodeHandle n;
    //建立了一个点云发布者
    ros::Publisher pub = n.advertise<sensor_msgs::PointCloud2>("/color_cloud", 1000);
    //点云更新频率2Hz
    ros::Rate rate(2);
    //点云大小为100
    unsigned int num_points = 100;
    //建立了一个pcl的点云（不能直接发布）
    pcl::PointCloud<pcl::PointXYZRGB> cloud;
    //点云初始化
    cloud.points.resize(num_points);
    //建立一个可以直接发布的点云
    sensor_msgs::PointCloud2 output_msg;
    while (ros::ok()) {
        output_msg.header.stamp = ros::Time::now();
        for (int i = 0; i < num_points; i++) {
            //点云中每个点位于一个10*10*10的方块内随机分布，颜色也随机
            // rand () / (RAND_MAX + 1.0f)为[0.1)   rand () / (RAND_MAX )为[0.1]
            cloud.points[i].x = 10 * rand() / (RAND_MAX + 1.0f);
            cloud.points[i].y = 10 * rand() / (RAND_MAX + 1.0f);
            cloud.points[i].z = 10 * rand() / (RAND_MAX + 1.0f);
            //(rand() % (b-a+1))+ a
            cloud.points[i].r = (rand() % (255 + 1));
            cloud.points[i].g = (rand() % (255 + 1));
            cloud.points[i].b = (rand() % (255 + 1));
        }
        //将点云转化为消息才能发布
        pcl::toROSMsg(cloud, output_msg);
        //frame_id为map，rviz中就不用改了
        output_msg.header.frame_id = "map";
        //发布出去
        pub.publish(output_msg);
	ROS_INFO("Published ... ");
        rate.sleep();
    }
    ros::spin();
    return 0;
}
